package org.openqa.selenium.devtools.v121.runtime.model;

import org.openqa.selenium.Beta;
import org.openqa.selenium.json.JsonInput;

/**
 * Number of milliseconds.
 */
public class TimeDelta {

    private final java.lang.Number timeDelta;

    public TimeDelta(java.lang.Number timeDelta) {
        this.timeDelta = java.util.Objects.requireNonNull(timeDelta, "Missing value for TimeDelta");
    }

    private static TimeDelta fromJson(JsonInput input) {
        return new TimeDelta(input.nextNumber());
    }

    public Number toJson() {
        return timeDelta;
    }

    public String toString() {
        return timeDelta.toString();
    }
}
