package org.openqa.selenium.devtools.v122.storage.model;

import org.openqa.selenium.Beta;
import org.openqa.selenium.json.JsonInput;

@org.openqa.selenium.Beta()
public class AttributionReportingTriggerSpec {

    private final java.util.List<java.lang.Number> triggerData;

    private final org.openqa.selenium.devtools.v122.storage.model.AttributionReportingEventReportWindows eventReportWindows;

    public AttributionReportingTriggerSpec(java.util.List<java.lang.Number> triggerData, org.openqa.selenium.devtools.v122.storage.model.AttributionReportingEventReportWindows eventReportWindows) {
        this.triggerData = java.util.Objects.requireNonNull(triggerData, "triggerData is required");
        this.eventReportWindows = java.util.Objects.requireNonNull(eventReportWindows, "eventReportWindows is required");
    }

    /**
     * number instead of integer because not all uint32 can be represented by
     * int
     */
    public java.util.List<java.lang.Number> getTriggerData() {
        return triggerData;
    }

    public org.openqa.selenium.devtools.v122.storage.model.AttributionReportingEventReportWindows getEventReportWindows() {
        return eventReportWindows;
    }

    private static AttributionReportingTriggerSpec fromJson(JsonInput input) {
        java.util.List<java.lang.Number> triggerData = null;
        org.openqa.selenium.devtools.v122.storage.model.AttributionReportingEventReportWindows eventReportWindows = null;
        input.beginObject();
        while (input.hasNext()) {
            switch(input.nextName()) {
                case "triggerData":
                    triggerData = input.readArray(java.lang.Number.class);
                    break;
                case "eventReportWindows":
                    eventReportWindows = input.read(org.openqa.selenium.devtools.v122.storage.model.AttributionReportingEventReportWindows.class);
                    break;
                default:
                    input.skipValue();
                    break;
            }
        }
        input.endObject();
        return new AttributionReportingTriggerSpec(triggerData, eventReportWindows);
    }
}
