package org.openqa.selenium.devtools.v122.storage.model;

import org.openqa.selenium.Beta;
import org.openqa.selenium.json.JsonInput;

/**
 * A cache's contents have been modified.
 */
public class CacheStorageContentUpdated {

    private final java.lang.String origin;

    private final java.lang.String storageKey;

    private final java.lang.String bucketId;

    private final java.lang.String cacheName;

    public CacheStorageContentUpdated(java.lang.String origin, java.lang.String storageKey, java.lang.String bucketId, java.lang.String cacheName) {
        this.origin = java.util.Objects.requireNonNull(origin, "origin is required");
        this.storageKey = java.util.Objects.requireNonNull(storageKey, "storageKey is required");
        this.bucketId = java.util.Objects.requireNonNull(bucketId, "bucketId is required");
        this.cacheName = java.util.Objects.requireNonNull(cacheName, "cacheName is required");
    }

    /**
     * Origin to update.
     */
    public java.lang.String getOrigin() {
        return origin;
    }

    /**
     * Storage key to update.
     */
    public java.lang.String getStorageKey() {
        return storageKey;
    }

    /**
     * Storage bucket to update.
     */
    public java.lang.String getBucketId() {
        return bucketId;
    }

    /**
     * Name of cache in origin.
     */
    public java.lang.String getCacheName() {
        return cacheName;
    }

    private static CacheStorageContentUpdated fromJson(JsonInput input) {
        java.lang.String origin = null;
        java.lang.String storageKey = null;
        java.lang.String bucketId = null;
        java.lang.String cacheName = null;
        input.beginObject();
        while (input.hasNext()) {
            switch(input.nextName()) {
                case "origin":
                    origin = input.nextString();
                    break;
                case "storageKey":
                    storageKey = input.nextString();
                    break;
                case "bucketId":
                    bucketId = input.nextString();
                    break;
                case "cacheName":
                    cacheName = input.nextString();
                    break;
                default:
                    input.skipValue();
                    break;
            }
        }
        input.endObject();
        return new CacheStorageContentUpdated(origin, storageKey, bucketId, cacheName);
    }
}
