package org.openqa.selenium.devtools.v122.storage.model;

import org.openqa.selenium.Beta;
import org.openqa.selenium.json.JsonInput;

/**
 * The full details of an interest group.
 */
public class InterestGroupDetails {

    private final java.lang.String ownerOrigin;

    private final java.lang.String name;

    private final org.openqa.selenium.devtools.v122.network.model.TimeSinceEpoch expirationTime;

    private final java.lang.String joiningOrigin;

    private final java.util.Optional<java.lang.String> biddingLogicURL;

    private final java.util.Optional<java.lang.String> biddingWasmHelperURL;

    private final java.util.Optional<java.lang.String> updateURL;

    private final java.util.Optional<java.lang.String> trustedBiddingSignalsURL;

    private final java.util.List<java.lang.String> trustedBiddingSignalsKeys;

    private final java.util.Optional<java.lang.String> userBiddingSignals;

    private final java.util.List<org.openqa.selenium.devtools.v122.storage.model.InterestGroupAd> ads;

    private final java.util.List<org.openqa.selenium.devtools.v122.storage.model.InterestGroupAd> adComponents;

    public InterestGroupDetails(java.lang.String ownerOrigin, java.lang.String name, org.openqa.selenium.devtools.v122.network.model.TimeSinceEpoch expirationTime, java.lang.String joiningOrigin, java.util.Optional<java.lang.String> biddingLogicURL, java.util.Optional<java.lang.String> biddingWasmHelperURL, java.util.Optional<java.lang.String> updateURL, java.util.Optional<java.lang.String> trustedBiddingSignalsURL, java.util.List<java.lang.String> trustedBiddingSignalsKeys, java.util.Optional<java.lang.String> userBiddingSignals, java.util.List<org.openqa.selenium.devtools.v122.storage.model.InterestGroupAd> ads, java.util.List<org.openqa.selenium.devtools.v122.storage.model.InterestGroupAd> adComponents) {
        this.ownerOrigin = java.util.Objects.requireNonNull(ownerOrigin, "ownerOrigin is required");
        this.name = java.util.Objects.requireNonNull(name, "name is required");
        this.expirationTime = java.util.Objects.requireNonNull(expirationTime, "expirationTime is required");
        this.joiningOrigin = java.util.Objects.requireNonNull(joiningOrigin, "joiningOrigin is required");
        this.biddingLogicURL = biddingLogicURL;
        this.biddingWasmHelperURL = biddingWasmHelperURL;
        this.updateURL = updateURL;
        this.trustedBiddingSignalsURL = trustedBiddingSignalsURL;
        this.trustedBiddingSignalsKeys = java.util.Objects.requireNonNull(trustedBiddingSignalsKeys, "trustedBiddingSignalsKeys is required");
        this.userBiddingSignals = userBiddingSignals;
        this.ads = java.util.Objects.requireNonNull(ads, "ads is required");
        this.adComponents = java.util.Objects.requireNonNull(adComponents, "adComponents is required");
    }

    public java.lang.String getOwnerOrigin() {
        return ownerOrigin;
    }

    public java.lang.String getName() {
        return name;
    }

    public org.openqa.selenium.devtools.v122.network.model.TimeSinceEpoch getExpirationTime() {
        return expirationTime;
    }

    public java.lang.String getJoiningOrigin() {
        return joiningOrigin;
    }

    public java.util.Optional<java.lang.String> getBiddingLogicURL() {
        return biddingLogicURL;
    }

    public java.util.Optional<java.lang.String> getBiddingWasmHelperURL() {
        return biddingWasmHelperURL;
    }

    public java.util.Optional<java.lang.String> getUpdateURL() {
        return updateURL;
    }

    public java.util.Optional<java.lang.String> getTrustedBiddingSignalsURL() {
        return trustedBiddingSignalsURL;
    }

    public java.util.List<java.lang.String> getTrustedBiddingSignalsKeys() {
        return trustedBiddingSignalsKeys;
    }

    public java.util.Optional<java.lang.String> getUserBiddingSignals() {
        return userBiddingSignals;
    }

    public java.util.List<org.openqa.selenium.devtools.v122.storage.model.InterestGroupAd> getAds() {
        return ads;
    }

    public java.util.List<org.openqa.selenium.devtools.v122.storage.model.InterestGroupAd> getAdComponents() {
        return adComponents;
    }

    private static InterestGroupDetails fromJson(JsonInput input) {
        java.lang.String ownerOrigin = null;
        java.lang.String name = null;
        org.openqa.selenium.devtools.v122.network.model.TimeSinceEpoch expirationTime = null;
        java.lang.String joiningOrigin = null;
        java.util.Optional<java.lang.String> biddingLogicURL = java.util.Optional.empty();
        java.util.Optional<java.lang.String> biddingWasmHelperURL = java.util.Optional.empty();
        java.util.Optional<java.lang.String> updateURL = java.util.Optional.empty();
        java.util.Optional<java.lang.String> trustedBiddingSignalsURL = java.util.Optional.empty();
        java.util.List<java.lang.String> trustedBiddingSignalsKeys = null;
        java.util.Optional<java.lang.String> userBiddingSignals = java.util.Optional.empty();
        java.util.List<org.openqa.selenium.devtools.v122.storage.model.InterestGroupAd> ads = null;
        java.util.List<org.openqa.selenium.devtools.v122.storage.model.InterestGroupAd> adComponents = null;
        input.beginObject();
        while (input.hasNext()) {
            switch(input.nextName()) {
                case "ownerOrigin":
                    ownerOrigin = input.nextString();
                    break;
                case "name":
                    name = input.nextString();
                    break;
                case "expirationTime":
                    expirationTime = input.read(org.openqa.selenium.devtools.v122.network.model.TimeSinceEpoch.class);
                    break;
                case "joiningOrigin":
                    joiningOrigin = input.nextString();
                    break;
                case "biddingLogicURL":
                    biddingLogicURL = java.util.Optional.ofNullable(input.nextString());
                    break;
                case "biddingWasmHelperURL":
                    biddingWasmHelperURL = java.util.Optional.ofNullable(input.nextString());
                    break;
                case "updateURL":
                    updateURL = java.util.Optional.ofNullable(input.nextString());
                    break;
                case "trustedBiddingSignalsURL":
                    trustedBiddingSignalsURL = java.util.Optional.ofNullable(input.nextString());
                    break;
                case "trustedBiddingSignalsKeys":
                    trustedBiddingSignalsKeys = input.readArray(java.lang.String.class);
                    break;
                case "userBiddingSignals":
                    userBiddingSignals = java.util.Optional.ofNullable(input.nextString());
                    break;
                case "ads":
                    ads = input.readArray(org.openqa.selenium.devtools.v122.storage.model.InterestGroupAd.class);
                    break;
                case "adComponents":
                    adComponents = input.readArray(org.openqa.selenium.devtools.v122.storage.model.InterestGroupAd.class);
                    break;
                default:
                    input.skipValue();
                    break;
            }
        }
        input.endObject();
        return new InterestGroupDetails(ownerOrigin, name, expirationTime, joiningOrigin, biddingLogicURL, biddingWasmHelperURL, updateURL, trustedBiddingSignalsURL, trustedBiddingSignalsKeys, userBiddingSignals, ads, adComponents);
    }
}
