package org.openqa.selenium.devtools.v123.storage.model;

import org.openqa.selenium.Beta;
import org.openqa.selenium.json.JsonInput;

@org.openqa.selenium.Beta()
public class AttributionReportingSourceRegistration {

    private final org.openqa.selenium.devtools.v123.network.model.TimeSinceEpoch time;

    private final java.lang.Integer expiry;

    private final java.util.List<org.openqa.selenium.devtools.v123.storage.model.AttributionReportingTriggerSpec> triggerSpecs;

    private final java.lang.Integer aggregatableReportWindow;

    private final org.openqa.selenium.devtools.v123.storage.model.AttributionReportingSourceType type;

    private final java.lang.String sourceOrigin;

    private final java.lang.String reportingOrigin;

    private final java.util.List<java.lang.String> destinationSites;

    private final org.openqa.selenium.devtools.v123.storage.model.UnsignedInt64AsBase10 eventId;

    private final org.openqa.selenium.devtools.v123.storage.model.SignedInt64AsBase10 priority;

    private final java.util.List<org.openqa.selenium.devtools.v123.storage.model.AttributionReportingFilterDataEntry> filterData;

    private final java.util.List<org.openqa.selenium.devtools.v123.storage.model.AttributionReportingAggregationKeysEntry> aggregationKeys;

    private final java.util.Optional<org.openqa.selenium.devtools.v123.storage.model.UnsignedInt64AsBase10> debugKey;

    private final org.openqa.selenium.devtools.v123.storage.model.AttributionReportingTriggerDataMatching triggerDataMatching;

    public AttributionReportingSourceRegistration(org.openqa.selenium.devtools.v123.network.model.TimeSinceEpoch time, java.lang.Integer expiry, java.util.List<org.openqa.selenium.devtools.v123.storage.model.AttributionReportingTriggerSpec> triggerSpecs, java.lang.Integer aggregatableReportWindow, org.openqa.selenium.devtools.v123.storage.model.AttributionReportingSourceType type, java.lang.String sourceOrigin, java.lang.String reportingOrigin, java.util.List<java.lang.String> destinationSites, org.openqa.selenium.devtools.v123.storage.model.UnsignedInt64AsBase10 eventId, org.openqa.selenium.devtools.v123.storage.model.SignedInt64AsBase10 priority, java.util.List<org.openqa.selenium.devtools.v123.storage.model.AttributionReportingFilterDataEntry> filterData, java.util.List<org.openqa.selenium.devtools.v123.storage.model.AttributionReportingAggregationKeysEntry> aggregationKeys, java.util.Optional<org.openqa.selenium.devtools.v123.storage.model.UnsignedInt64AsBase10> debugKey, org.openqa.selenium.devtools.v123.storage.model.AttributionReportingTriggerDataMatching triggerDataMatching) {
        this.time = java.util.Objects.requireNonNull(time, "time is required");
        this.expiry = java.util.Objects.requireNonNull(expiry, "expiry is required");
        this.triggerSpecs = java.util.Objects.requireNonNull(triggerSpecs, "triggerSpecs is required");
        this.aggregatableReportWindow = java.util.Objects.requireNonNull(aggregatableReportWindow, "aggregatableReportWindow is required");
        this.type = java.util.Objects.requireNonNull(type, "type is required");
        this.sourceOrigin = java.util.Objects.requireNonNull(sourceOrigin, "sourceOrigin is required");
        this.reportingOrigin = java.util.Objects.requireNonNull(reportingOrigin, "reportingOrigin is required");
        this.destinationSites = java.util.Objects.requireNonNull(destinationSites, "destinationSites is required");
        this.eventId = java.util.Objects.requireNonNull(eventId, "eventId is required");
        this.priority = java.util.Objects.requireNonNull(priority, "priority is required");
        this.filterData = java.util.Objects.requireNonNull(filterData, "filterData is required");
        this.aggregationKeys = java.util.Objects.requireNonNull(aggregationKeys, "aggregationKeys is required");
        this.debugKey = debugKey;
        this.triggerDataMatching = java.util.Objects.requireNonNull(triggerDataMatching, "triggerDataMatching is required");
    }

    public org.openqa.selenium.devtools.v123.network.model.TimeSinceEpoch getTime() {
        return time;
    }

    /**
     * duration in seconds
     */
    public java.lang.Integer getExpiry() {
        return expiry;
    }

    public java.util.List<org.openqa.selenium.devtools.v123.storage.model.AttributionReportingTriggerSpec> getTriggerSpecs() {
        return triggerSpecs;
    }

    /**
     * duration in seconds
     */
    public java.lang.Integer getAggregatableReportWindow() {
        return aggregatableReportWindow;
    }

    public org.openqa.selenium.devtools.v123.storage.model.AttributionReportingSourceType getType() {
        return type;
    }

    public java.lang.String getSourceOrigin() {
        return sourceOrigin;
    }

    public java.lang.String getReportingOrigin() {
        return reportingOrigin;
    }

    public java.util.List<java.lang.String> getDestinationSites() {
        return destinationSites;
    }

    public org.openqa.selenium.devtools.v123.storage.model.UnsignedInt64AsBase10 getEventId() {
        return eventId;
    }

    public org.openqa.selenium.devtools.v123.storage.model.SignedInt64AsBase10 getPriority() {
        return priority;
    }

    public java.util.List<org.openqa.selenium.devtools.v123.storage.model.AttributionReportingFilterDataEntry> getFilterData() {
        return filterData;
    }

    public java.util.List<org.openqa.selenium.devtools.v123.storage.model.AttributionReportingAggregationKeysEntry> getAggregationKeys() {
        return aggregationKeys;
    }

    public java.util.Optional<org.openqa.selenium.devtools.v123.storage.model.UnsignedInt64AsBase10> getDebugKey() {
        return debugKey;
    }

    public org.openqa.selenium.devtools.v123.storage.model.AttributionReportingTriggerDataMatching getTriggerDataMatching() {
        return triggerDataMatching;
    }

    private static AttributionReportingSourceRegistration fromJson(JsonInput input) {
        org.openqa.selenium.devtools.v123.network.model.TimeSinceEpoch time = null;
        java.lang.Integer expiry = 0;
        java.util.List<org.openqa.selenium.devtools.v123.storage.model.AttributionReportingTriggerSpec> triggerSpecs = null;
        java.lang.Integer aggregatableReportWindow = 0;
        org.openqa.selenium.devtools.v123.storage.model.AttributionReportingSourceType type = null;
        java.lang.String sourceOrigin = null;
        java.lang.String reportingOrigin = null;
        java.util.List<java.lang.String> destinationSites = null;
        org.openqa.selenium.devtools.v123.storage.model.UnsignedInt64AsBase10 eventId = null;
        org.openqa.selenium.devtools.v123.storage.model.SignedInt64AsBase10 priority = null;
        java.util.List<org.openqa.selenium.devtools.v123.storage.model.AttributionReportingFilterDataEntry> filterData = null;
        java.util.List<org.openqa.selenium.devtools.v123.storage.model.AttributionReportingAggregationKeysEntry> aggregationKeys = null;
        java.util.Optional<org.openqa.selenium.devtools.v123.storage.model.UnsignedInt64AsBase10> debugKey = java.util.Optional.empty();
        org.openqa.selenium.devtools.v123.storage.model.AttributionReportingTriggerDataMatching triggerDataMatching = null;
        input.beginObject();
        while (input.hasNext()) {
            switch(input.nextName()) {
                case "time":
                    time = input.read(org.openqa.selenium.devtools.v123.network.model.TimeSinceEpoch.class);
                    break;
                case "expiry":
                    expiry = input.nextNumber().intValue();
                    break;
                case "triggerSpecs":
                    triggerSpecs = input.readArray(org.openqa.selenium.devtools.v123.storage.model.AttributionReportingTriggerSpec.class);
                    break;
                case "aggregatableReportWindow":
                    aggregatableReportWindow = input.nextNumber().intValue();
                    break;
                case "type":
                    type = input.read(org.openqa.selenium.devtools.v123.storage.model.AttributionReportingSourceType.class);
                    break;
                case "sourceOrigin":
                    sourceOrigin = input.nextString();
                    break;
                case "reportingOrigin":
                    reportingOrigin = input.nextString();
                    break;
                case "destinationSites":
                    destinationSites = input.readArray(java.lang.String.class);
                    break;
                case "eventId":
                    eventId = input.read(org.openqa.selenium.devtools.v123.storage.model.UnsignedInt64AsBase10.class);
                    break;
                case "priority":
                    priority = input.read(org.openqa.selenium.devtools.v123.storage.model.SignedInt64AsBase10.class);
                    break;
                case "filterData":
                    filterData = input.readArray(org.openqa.selenium.devtools.v123.storage.model.AttributionReportingFilterDataEntry.class);
                    break;
                case "aggregationKeys":
                    aggregationKeys = input.readArray(org.openqa.selenium.devtools.v123.storage.model.AttributionReportingAggregationKeysEntry.class);
                    break;
                case "debugKey":
                    debugKey = java.util.Optional.ofNullable(input.read(org.openqa.selenium.devtools.v123.storage.model.UnsignedInt64AsBase10.class));
                    break;
                case "triggerDataMatching":
                    triggerDataMatching = input.read(org.openqa.selenium.devtools.v123.storage.model.AttributionReportingTriggerDataMatching.class);
                    break;
                default:
                    input.skipValue();
                    break;
            }
        }
        input.endObject();
        return new AttributionReportingSourceRegistration(time, expiry, triggerSpecs, aggregatableReportWindow, type, sourceOrigin, reportingOrigin, destinationSites, eventId, priority, filterData, aggregationKeys, debugKey, triggerDataMatching);
    }
}
